
require 'attr_extras/explicit'
require 'docker'
require 'excon'
require 'fileutils'
require 'memoist'

require_relative 'drydock/docker_api_patch'

module Drydock # :nodoc:
end

require_relative 'drydock/drydock'
require_relative 'drydock/logger'
require_relative 'drydock/errors'
require_relative 'drydock/formatters'
require_relative 'drydock/runtime_options'

require_relative 'drydock/container_config'
require_relative 'drydock/image_repository'

require_relative 'drydock/cli_flags'
require_relative 'drydock/file_manager'
require_relative 'drydock/ignorefile_definition'
require_relative 'drydock/phase'
require_relative 'drydock/phase_chain'
require_relative 'drydock/project'
require_relative 'drydock/stream_monitor'
require_relative 'drydock/tar_writer'

require_relative 'drydock/instructions/copy'

require_relative 'drydock/object_caches/filesystem_cache'
require_relative 'drydock/object_caches/in_memory_cache'
require_relative 'drydock/object_caches/no_cache'

require_relative 'drydock/plugins/apk'
require_relative 'drydock/plugins/npm'
require_relative 'drydock/plugins/rubygems'
